//---------------------------------------------------------------------------
#ifndef ABH
#define ABH
//---------------------------------------------------------------------------
#include <iostream.h>
//---------------------------------------------------------------------------
struct Odcinek
{
  int a, b;

  void Porzadkuj() {if (a>b) {int z=a; a=b; b=z;}}
};
//---------------------------------------------------------------------------
struct Odcinki
{
  Odcinek *o;
  int ile;

  Odcinki() {o=0; ile=0;}
  ~Odcinki() {delete[] o;}

  void Porzadkuj();

  Odcinek &operator[](int i) {return o[i];}

  friend istream& operator>>(istream& is, Odcinki &);
};
//---------------------------------------------------------------------------
class Sasiedzi
{
	int ile;
	int *ileS;
	int **s;

  public:
	Sasiedzi() {s = 0; ileS = 0; ile = 0;}
	~Sasiedzi() {Usun();}

	void Usun();
	void Wyznacz(int n, Odcinki &o);

	int IleS(int i) {return ileS[i];}
	int *operator[](int i) {return s[i];}
};
//---------------------------------------------------------------------------
class ZadanieAB
{
	// Podstawowe dane
	int n, m;		// liczby wierzchokw i przektnych
	Odcinki o;	    // tablica odcinkw

	// Rezultaty
	bool sukces;
	int *numer; 	// numery kolejnych wierzchokw

	// Dane pomocnicze
	Sasiedzi s;		// informacje o ssiedztwie
	int ileWyzn;	// ile wierzchokw wyznaczono
	int *poz;		// na ktrej pozycji
	int *sasiad;	// ktry ssiad uyty

	// Metody pomocnicze
	void Start();

	void Dodaj(int i);
	void Zdejmij();

	bool Naprzod();
	bool Wstecz();
	bool JedenKrok();
	bool ZamykaSie();
	bool NieMaPrzeciec();

  public:
	ZadanieAB() {numer=poz=sasiad=0;}
	~ZadanieAB();

	bool Rozwiaz();

	friend istream& operator>>(istream& is, ZadanieAB &ab);
	friend ostream& operator<<(ostream& os, const ZadanieAB &ab);
};
//---------------------------------------------------------------------------
#endif
